//---------------------------------------------------------------------------


//#include <vcl.h>
#pragma hdrstop
   #include "MainUnit.h"
#include "InspFrmUnit.h"
#include "LayerUnit.h"
#include "LibShowUnit.h"
#include "SetupFrmUnit.h"
#include "TurboFrmUnit.h"
#include "AboutBoxUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cad"
#pragma link "RsRuler"
#pragma link "InspCtrl"
#pragma link "CompInsp"
#pragma link "RsRuler"
#pragma link "DXFExportImport"
//#pragma link "Dialogs"
#pragma link "cad"
#pragma link "RsRuler"
#pragma resource "*.dfm"
TMainFrm *MainFrm;
AnsiString EditingFileName;
char TempString[100];
TPoint mDes,mOrg;
//---------------------------------------------------------------------------
__fastcall TMainFrm::TMainFrm(TComponent* Owner)
	: TForm(Owner)
{

}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SelectBtnClick(TObject *Sender)
{
  MyCAD1->ShapeTool = SpSelecting;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::RotateSelectBtnClick(TObject *Sender)
{
 MyCAD1->ShapeTool = SpRotateSelecting;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpLineBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpLine;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpeedButton4Click(TObject *Sender)
{
MyCAD1->ShapeTool = SpLinkLine;	
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpRectangleBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpRectangle;	
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpeedButton6Click(TObject *Sender)
{
MyCAD1->ShapeTool = SpLineLinkLine;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpRulelineBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpRuleLine;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpeedButton5Click(TObject *Sender)
{
MyCAD1->ShapeTool = SpPolylinePolygonPointAdding;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpPolyLineBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpPolyLine;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpeedButton7Click(TObject *Sender)
{
MyCAD1->ShapeTool = SpPolylinePolygonPointRemoving;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpPolygonBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpPolygon;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpTextBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpText;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpArcBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpElliArc;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpImageBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpImage;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpEllipseBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpEllipse;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpeedButton1Click(TObject *Sender)
{
MyCAD1->ShapeTool = SpPolyBezier;
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpeedButton3Click(TObject *Sender)
{
AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::FileNewExecute(TObject *Sender)
{
//if (Application->MessageBox("Begin a new drawing?", "Action", MB_YESNOCANCEL)==IDYES)
//   {
   MyCAD1->DeSelectedAllShapesByCode();
   SetInspector();

   if  (SaveEditingFile())
	  {
	   MyCAD1->ClearAllUndoStuff();
	   MyCAD1->DeleteAllShapes();
	   MyCAD1->Global_Changed = false;
	  }
   }
//}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SetInspector(void)
{
int i;

InspFrm->ComponentComboBox1->Root = MyCAD1;

if (MyCAD1->GetSelectedShapesCount() >= 2)
   {
   //if (!InspectorAll)
   //	  break;
   // do not inpsector when  more shapes selected
   // fast to do!

   InspFrm->ComponentInspector1->Instance = MyCAD1->GetSelectedShapes()[0];//[0];

   for (int i = 0; i < MyCAD1->GetSelectedShapesCount(); i++)
	  InspFrm->ComponentInspector1->AddInstance(MyCAD1->GetSelectedShapes()[i]);
   }
else
   {
   if (MyCAD1->GetSelectedShapesCount() == 0)
	  {
	  InspFrm->ComponentComboBox1->Instance = MyCAD1;
	  }
  else
	  {
	  InspFrm->ComponentComboBox1->Instance = MyCAD1->GetSelectedShape();
	  }

  InspFrm->ComponentInspector1->Instance = InspFrm->ComponentComboBox1->Instance;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SetInspectorChild(TMyShape* ChildShape)
{
  InspFrm->ComponentComboBox1->Root = MyCAD1;
  InspFrm->ComponentComboBox1->Instance = ChildShape;
  InspFrm->ComponentInspector1->Instance = ChildShape;
}

//---------------------------------------------------------------------------
void __fastcall TMainFrm::CenterCAD(void)
{
   MyCAD1->Left = (ScrollBox1->Width  - MyCAD1->Width)/2;
   MyCAD1->Top  = (ScrollBox1->Height - MyCAD1->Height)/2;
}

//---------------------------------------------------------------------------
bool __fastcall TMainFrm::SaveEditingFile(void)
{
int AWord;
//  result is user press cancel button or not.
bool result = true;
if (MyCAD1->Global_Changed)
   {
   //AWord = MessageDlg("File [EditingFileName] has changed, do you want to save it?", "",  mtConfirmation, [mbYes, mbNo, mbCancel], 0);
   if(AWord == mrYes)
	  {
	  if (EditingFileName == "NoName.TCAD")
		 {
		 FileSaveAs->Execute();
		 }
	  else
		 {
		 if (MyCAD1->SaveToFile(EditingFileName))
			{
			ShowMessage("MyCAD1 has been saved to " + EditingFileName);
			result = true;
			}
		 }
	  if  (AWord == mrNo)
		 {
		 result = true;
		 }
	  if  (AWord == mrCancel)
		 {
		 result = false;
		 }
	  }
   }
return result;
}

void __fastcall TMainFrm::FileOpenAccept(TObject *Sender)
{
if(SaveEditingFile())
   {
   if (EditingFileName != "NoName.TCAD")
	  {
	  FileOpen->Dialog->InitialDir = ExtractFilePath(EditingFileName);
	  }
   else
	  {
	  FileOpen->Dialog->InitialDir =  ExtractFilePath(Application->ExeName) + "samples\\";
	  }

   InspFrm->ComponentInspector1->Root = MainFrm->MyCAD1;
   InspFrm->ComponentInspector1->Instance = MainFrm->MyCAD1;

   if (FileExists(FileOpen->Dialog->FileName))
	  {
	  if (MyCAD1->IsTCADFile(FileOpen->Dialog->FileName))
		 {
		 if (!MyCAD1->LoadFromFile(FileOpen->Dialog->FileName))
			{
			ShowMessage("Error when read file");
			}
		  else
			{
			ZoomCmbBox->ItemIndex = 2;
			CenterCAD();
			LayerFrm->Refresh();
			EditingFileName = FileOpen->Dialog->FileName;
			}
		 }
	  else
		 {
		 ShowMessage(FileOpen->Dialog->FileName + " is not a TCAD format file");
		 }
	  }
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::FileOpenlibBeforeExecute(TObject *Sender)
{
   {
   FileOpenlib->Dialog->InitialDir =  ExtractFilePath(Application->ExeName) ;//+ "lib\";
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::FileOpenlibAccept(TObject *Sender)
{
if (FileExists(FileOpenlib->Dialog->FileName))
   {
   const AnsiString TempString = FileOpenlib->Dialog->FileName;
   //String* TempStringPtr = &TempString;

   LibShowFrm->LoadLib(TempString);
   LibShowFrm->Show();
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::wndInspectorExecute(TObject *Sender)
{
InspFrm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::wndLayerExecute(TObject *Sender)
{
LayerFrm->Show();	
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::wndLibExecute(TObject *Sender)
{
LibShowFrm->Show();	
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1ActionToolToSelecting()
{
SelectBtn->Down = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1ChildShapeSelected(TMyShape *SelectedChildShape,
      bool &AcceptSelect)
{
	ASelectedChildShape = SelectedChildShape;
	MonitorParentShapesOnly = false;
	SetInspectorChild(SelectedChildShape);
	AcceptSelect = true;
  //if you do not need tigger this event,please write this code only:
  //AcceptSelect = false;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1DragDrop(TObject *Sender, TObject *Source,
	  int X, int Y)
{
if (Source->ClassNameIs("TListView"))
   {
   LibShowFrm->mListView = (TListView*)Source ;
   MyCAD1->AddUserDefineShapefromLib(LibShowFrm->mLibManager, LibShowFrm->mListView->Selected->Caption,X,Y,MyCAD1);
   RefreshMenu();
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1DragOver(TObject *Sender, TObject *Source,
      int X, int Y, TDragState State, bool &Accept)
{
 Accept = Source->ClassNameIs("TListView");
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1MouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
if (ZoomIn->Down || ZoomOut->Down)
   {
   MyCAD1->Canvas->Brush->Style = bsClear;
   MyCAD1->Canvas->Pen->Mode = pmXor;
   MyCAD1->Canvas->Pen->Style = psDot ;
   MyCAD1->Canvas->Pen->Color = clBlack;
   mOrg = Point(X,Y);
   mDes = mOrg;
   mDown = true;
   MyCAD1->ShapeTool = SpClose;
   }

if (DragBtn->Down)
   {
   mOrg = Point(X,Y);
   mDes = mOrg;
   mDown = true;
   MyCAD1->ShapeTool = SpClose;
   }
}
//---------------------------------------------------------------------------
//Checked by P.Hales
void __fastcall TMainFrm::MyCAD1MouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
RsRuler1->HairLinePos = MyCAD1->Left+X;
RsRuler2->HairLinePos = MyCAD1->Top+Y;

if (ZoomIn->Down||ZoomOut->Down)
   {
   if (mDown)
	  {
	  MyCAD1->Canvas->Rectangle(mOrg.x, mOrg.y, mDes.x, mDes.y);
	  MyCAD1->Canvas->Brush->Style = bsClear;
	  MyCAD1->Canvas->Pen->Mode = pmXor;
	  MyCAD1->Canvas->Pen->Style = psDot;
	  MyCAD1->Canvas->Pen->Color = clRed;
	  mDes.x = X;
	  mDes.y = Y;
	  MyCAD1->Canvas->Rectangle(mOrg.x,mOrg.y,mDes.x,mDes.y);
	  }
   }
else
   {
   if (mDown)
	  {
	  if((MyCAD1->Left + MyCAD1->Width > ScrollBox1->Width)||(MyCAD1->Left < 0))
		 {
		 if (X - mOrg.x < 0)
			{
			if (MyCAD1->Left + MyCAD1->Width > ScrollBox1->Width)
			   {
			   if (MyCAD1->Left + MyCAD1->Width + (X - mOrg.x) < ScrollBox1->Width)
				  {
				  MyCAD1->Left = ScrollBox1->Width - MyCAD1->Width;
				  }
			   else
				  {
				  MyCAD1->Left =  MyCAD1->Left +(X - mOrg.x);
				  }
			   }
			}
		 else
			{
			if (MyCAD1->Left < 0)
			   {
			   if (MyCAD1->Left +(X - mOrg.x) > 0)
				  {
				  MyCAD1->Left = 0;
				  }
			   else
				  {
				  MyCAD1->Left =  MyCAD1->Left +(X - mOrg.x);
				  }
			   }
			}
		 }
	  }
   }

 if (MyCAD1->Top +MyCAD1->Height > ScrollBox1->Height || MyCAD1->Top <0)
   {
   if (Y - mOrg.y < 0)
	  {
	  if (MyCAD1->Top + MyCAD1->Height > ScrollBox1->Height)
		 {
		 if  (MyCAD1->Top + MyCAD1->Height + (Y - mOrg.y) <  ScrollBox1->Height)
			{
			MyCAD1->Top = ScrollBox1->Height - MyCAD1->Height;
			}
		 else
			{
			MyCAD1->Top =  MyCAD1->Top +(Y-mOrg.y);
			}
		 }
	  }
   else
	  {
	  if (MyCAD1->Top < 0)
		 {
		 if (MyCAD1->Top +(Y - mOrg.y) > 0)
			{
			MyCAD1->Top = 0;
			}
		 else
			{
			MyCAD1->Top =  MyCAD1->Top +(Y - mOrg.y);
			}
		 }
	  }
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1MouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
int L;

if (ZoomIn->Down)
   {
   mDown =  false;
   X = mOrg.x +( X - mOrg.x )/ 2 ;
   Y = mOrg.y +( Y - mOrg.y )/ 2 ;
   MyCAD1->Zoom = MyCAD1->Zoom*1.2;
   if (MyCAD1->Width <=ScrollBox1->Width)
	  {
	  MyCAD1->Left = (ScrollBox1->Width - MyCAD1->Width)/2;
	  }
   else
	  {
	  L =  Ceil(ScrollBox1->Width / 2  - X*1.2);
	  if (L > 0)
		 MyCAD1->Left = 0;
	  else
		 MyCAD1->Left =  L;
	  }

   if (MyCAD1->Height <=ScrollBox1->Height)
	  {
	  MyCAD1->Top = (ScrollBox1->Height - MyCAD1->Height)/2;
	  }
   else
	  {
	  L =  Ceil(ScrollBox1->Height / 2  - Y*1.2);
	  if (L > 0)
		 {
		 MyCAD1->Top = 0;
		 }
	  else
		 {
		 MyCAD1->Top =  L;
		 }
	  }
   ZoomCmbBox->Text =  IntToStr(Ceil(MyCAD1->Zoom*100))+"%";
   }

if (ZoomOut->Down)
   {
   mDown = false;
   MyCAD1->Zoom = MyCAD1->Zoom * 0.8;
   if (MyCAD1->Width <=ScrollBox1->Width)
	  MyCAD1->Left = (ScrollBox1->Width - MyCAD1->Width)/2;
   else
	  {
	  L =  Ceil(ScrollBox1->Width/2 - X*0.8);
	  if (L > 0)
		 MyCAD1->Left = 0;
	  else
		 MyCAD1->Left =  L;
	  }

   if (MyCAD1->Height <= ScrollBox1->Height)
	  {
	  MyCAD1->Top = (ScrollBox1->Height - MyCAD1->Height)/2;
	  }
	  else
	  {
	  L = Ceil(ScrollBox1->Height/2 - Y*0.8);

	  if (L > 0)
		 MyCAD1->Top = 0;
	  else
		 MyCAD1->Top = L;
	  }
   ZoomCmbBox->Text = IntToStr(Ceil(MyCAD1->Zoom*100))+"%";
   }

if (DragBtn->Down)
   mDown = false;

RefreshMenu();
SetRuler();

if (MyCAD1->GetSelectedShape() == NULL)
   SetInspector();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1ShapeAdded(TMyShape *&AShape, int ShapeCount)
{
Graphics::TBitmap* ABitmap = new Graphics::TBitmap;

MyCAD1->ReleaseCursorClipArea();
/*
  EventMemo->Lines->Add("---------Add Event");
  EventMemo->Lines->Add("You Add a Shape,it is :" + ShapeName + ",in Layer " +
	inttostr(LayerId) + ", it is  a " + AShape->ClassName + ",Now CAD has " +
	inttostr(ShapeCount) + "Shapes");
*/

if (AShape != NULL)
   {
   if (AShape->ClassNameIs("TMyImage"))
	  {
	  if (OpenPictureDialog1->Execute())
		 {
		 ABitmap = LoadGraphicsFile(OpenPictureDialog1->FileName);
		 MyCAD1->SetMyImage(AShape->ShapeId,ABitmap) ;
		 delete ABitmap;
		 }
	  }
   }

if ((InspFrm != NULL) && (AShape != NULL))
   {
   InspFrm->ComponentInspector1->Root =  AShape;
   InspFrm->ComponentInspector1->Instance = AShape;
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1ShapeSelected(TMyShape *LastSelectedShape,
	  TMyShape *SelectedShape)
{
   ASelectedChildShape = NULL;
   MonitorParentShapesOnly = true;
   SetInspector();

   /*************************************************
   note: if you select a behind shape, this event will be happen twice:
	  one is the big shape;other is for    behind shape;


   *****************************************************/

 /*  if  LastSelectedShape <> nil then
	  Memo1->Lines->Add(" Last shape id is "+ LastSelectedShape->name+  ",in Layer " + inttostr(LastSelectedShape->LayerId) + " , it is  a " + LastSelectedShape->ClassName)
	   else
		 Memo1->Lines->Add("nil");
	if SelectedShape <> nil then
	  Memo1->Lines->Add("Now you selected "+SelectedShape->name   + ",in Layer " + inttostr(SelectedShape->LayerId) + ", it is  a " + SelectedShape->ClassName)
		 else
		 Memo1->Lines->Add("nil");
*/
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::RefreshMenu(void)
{
EditDelete1->Enabled =  MyCAD1->GetSelectedShapesCount() > 0;
EditBringtoFront->Enabled  =  MyCAD1->GetSelectedShapesCount() > 0;
EditSendToBack->Enabled  =  MyCAD1->GetSelectedShapesCount() > 0;
EditBringtoFrontByStep->Enabled  =  MyCAD1->GetSelectedShapesCount() > 0;
EditSendBackByStep->Enabled  =  MyCAD1->GetSelectedShapesCount() > 0;

EditunGroupShape->Enabled =  MyCAD1->GetSelectedShapesCount() == 1;
EditGroupShape->Enabled =  MyCAD1->GetSelectedShapesCount() > 0;
AlignAlignTop->Enabled =  MyCAD1->GetSelectedShapesCount() >1;
AlignAlignBottom->Enabled =  AlignAlignTop->Enabled;
AlignAlignLeft->Enabled =  AlignAlignTop->Enabled;
AlignAlignRight->Enabled =  AlignAlignTop->Enabled;
AlignAlignHorCenter->Enabled =  AlignAlignTop->Enabled;
AlignAlignVertCenter->Enabled =  AlignAlignTop->Enabled;

EditCopy1->Enabled =   MyCAD1->GetSelectedShapesCount() > 0;
EditCut1->Enabled =   MyCAD1->GetSelectedShapesCount() > 0;
EditPaste1->Enabled =   MyCAD1->GetMemShapesCount() > 0;

if(MyCAD1->GetSelectedShapesCount() == 1)
   {
   EditLock->Enabled = !MyCAD1->GetSelectedShape()->Locked;
   }
else
   {
   if (MyCAD1->GetSelectedShapesCount() > 1)
	  {
	  EditLock->Enabled = true;
	  }
   else
	  {
	  EditLock->Enabled = false;
	  }
   }
EditUndo1->Enabled = true;
}

void __fastcall TMainFrm::SetRuler(void)
{
RsRuler1->Scale = Ceil(MyCAD1->Zoom*100);
RsRuler1->Offset =-MyCAD1->Left/MyCAD1->Zoom;

RsRuler2->Scale = Ceil(MyCAD1->Zoom*100);
RsRuler2->Offset = -MyCAD1->Top/MyCAD1->Zoom;
}
void __fastcall TMainFrm::EditGroupShapeExecute(TObject *Sender)
{
MyCAD1->GroupWorkingShape();
RefreshMenu();
SetInspector();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditunGroupShapeExecute(TObject *Sender)
{

if (MyCAD1->GetSelectedShapesCount() == 1)
   {
   MyCAD1->UnGroupShape(MyCAD1->GetSelectedShape());
   }
else
   {
   ShowMessage("No shape selected or more shapes selected!");
   }

RefreshMenu();
SetInspector();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditSendToBackExecute(TObject *Sender)
{
  MyCAD1->SendToBack(MyCAD1->GetSelectedShape());
  RefreshMenu();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditBringtoFrontExecute(TObject *Sender)
{
  MyCAD1->BringToFront(MyCAD1->GetSelectedShape());
  RefreshMenu();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditSendBackByStepExecute(TObject *Sender)
{
MyCAD1->SendToBackByStep(MyCAD1->GetSelectedShape());
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditBringtoFrontByStepExecute(TObject *Sender)
{
MyCAD1->BringToFrontByStep(MyCAD1->GetSelectedShape());
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AlignAlignTopExecute(TObject *Sender)
{
 MyCAD1->AlignTop();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AlignAlignBottomExecute(TObject *Sender)
{
MyCAD1->AlignBottom();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AlignAlignLeftExecute(TObject *Sender)
{
MyCAD1->AlignLeft();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AlignAlignRightExecute(TObject *Sender)
{
MyCAD1->AlignRight();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AlignAlignHorCenterExecute(TObject *Sender)
{
MyCAD1->AlignHorizontalCenter();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AlignAlignVertCenterExecute(TObject *Sender)
{
MyCAD1->AlignVerticalCenter();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::FileSaveAsAccept(TObject *Sender)
{
if (MyCAD1->SaveToFile(FileSaveAs->Dialog->FileName))
   ShowMessage("MyCAD1 has been saved to " + FileSaveAs->Dialog->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditFlipVertExecute(TObject *Sender)
{
MyCAD1->FlipVert(MyCAD1->GetSelectedShape());	
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditFlipHorizExecute(TObject *Sender)
{
MyCAD1->FlipHoriz(MyCAD1->GetSelectedShape());	
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::zmZoominExecute(TObject *Sender)
{
if (MyCAD1->Zoom*2 < 100)
   {
   MyCAD1->Zoom = MyCAD1->Zoom * 2;
   ZoomCmbBox->Text = IntToStr(Ceil(MyCAD1->Zoom*100))+"%";
   CenterCAD();
   SetRuler();
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::zmZoomoutExecute(TObject *Sender)
{
if (MyCAD1->Zoom/2 > 0.01)
   {
   MyCAD1->Zoom = MyCAD1->Zoom / 2;
   ZoomCmbBox->Text = IntToStr(Ceil(MyCAD1->Zoom*100))+"%";
   CenterCAD();
   SetRuler();
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::opToggleGridExecute(TObject *Sender)
{
 MyCAD1->GridOperation->GridShow = !MyCAD1->GridOperation->GridShow;
 MyCAD1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::opSnaptoGridExecute(TObject *Sender)
{
MyCAD1->Snap = !MyCAD1->Snap;	
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::opPixelGridExecute(TObject *Sender)
{
MyCAD1->GridOperation->GridType = gPixel;
MyCAD1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::opLineGridExecute(TObject *Sender)
{
MyCAD1->GridOperation->GridType = gLine;
MyCAD1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::csDeSelectShapeExecute(TObject *Sender)
{
MyCAD1->DeSelectedAllShapesByCode();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::csSelectShapeExecute(TObject *Sender)
{
MyCAD1->SelectShapeByCode(1);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::csSelectMoreShapesExecute(TObject *Sender)
{
MyCAD1->SelectShapeByCode(2,false);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::csSelectallShapeExecute(TObject *Sender)
{
 MyCAD1->SelectAllShapes();
 RefreshMenu();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::CdSelectingExecute(TObject *Sender)
{
MyCAD1->ShapeTool = SpSelecting;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdLineExecute(TObject *Sender)
{
  if (MyCAD1->GetShapeByName("LineShape") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 13;
   MyPoint[0].Y = 4;
   MyPoint[1].X = 40;
   MyPoint[1].Y = 50;
   MyPoint[2].X = 40;
   MyPoint[2].Y = 90;

   TMyPoint *pMyPoint = MyPoint;

   MyCAD1->AddShapeByCode(MyCAD1, SpLine, "LineShape", pMyPoint, 2);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdRuleLineExecute(TObject *Sender)
{
if (MyCAD1->GetShapeByName("RuleLineShape") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 131;
   MyPoint[0].Y = 41;
   MyPoint[1].X = 140;
   MyPoint[1].Y = 150;
   MyPoint[2].X = 40;
   MyPoint[2].Y = 90;

   TMyPoint *pMyPoint = MyPoint;

   //ShowMessage("MyCAD1.AddShapeByCode(spRuleLine,[MyPoint(131,41),MyPoint(140,150)]);");
   MyCAD1->AddShapeByCode(MyCAD1, SpLine, "RuleLineShape", pMyPoint, 1);
   //MyCAD1->AddShapeByCode(MyCAD1,spRuleLine, "RuleLineShape", [MyPoint(131, 41), MyPoint(140,150)]);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdPolygonExecute(TObject *Sender)
{
if (MyCAD1->GetShapeByName("PolygonShapeArray") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 390;
   MyPoint[0].Y = 11;
   MyPoint[1].X = 380;
   MyPoint[1].Y = 70;
   MyPoint[2].X = 210;
   MyPoint[2].Y = 10;
   MyPoint[3].X = 110;
   MyPoint[3].Y = 190;

   TMyPoint *pMyPoint = MyPoint;
   MyCAD1->AddShapeByCode(MyCAD1, SpPolygon, "PolygonShapeArray", pMyPoint, 3);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdArcExecute(TObject *Sender)
{
if (MyCAD1->GetShapeByName("ArcShape") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 330;
   MyPoint[0].Y = 211;
   MyPoint[1].X = 380;
   MyPoint[1].Y = 211;
   MyPoint[2].X = 380;
   MyPoint[2].Y = 270;
   MyPoint[3].X = 110;
   MyPoint[3].Y = 190;

   TMyPoint *pMyPoint = MyPoint;
   int AShapeID = MyCAD1->AddShapeByCode(MyCAD1, SpElliArc, "ArcShape", pMyPoint, 2, 0);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditDelete1Execute(TObject *Sender)
{
//some one may delete the text in inspector form
if(!InspFrm->Active)
   {

   InspFrm->ComponentComboBox1->Root = NULL;
   InspFrm->ComponentInspector1->Instance = NULL;

   if(ASelectedChildShape == NULL)
	  {
	  MyCAD1->DeleteSelectedShapes();
	  }

   SetInspector();

   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditCopy1Execute(TObject *Sender)
{
MyCAD1->Copy();
RefreshMenu();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditCut1Execute(TObject *Sender)
{
MyCAD1->Cut();
RefreshMenu();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditPaste1Execute(TObject *Sender)
{
MyCAD1->Paste();
RefreshMenu();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::FilePageSetupExecute(TObject *Sender)
{
SetupFrm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdPolyLineExecute(TObject *Sender)
{
if (MyCAD1->GetShapeByName("PolyLineShape") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 90;
   MyPoint[0].Y = 11;
   MyPoint[1].X = 80;
   MyPoint[1].Y = 70;
   MyPoint[2].X = 110;
   MyPoint[2].Y = 120;
   MyPoint[3].X = 10;
   MyPoint[3].Y = 120;

   TMyPoint *pMyPoint = MyPoint;
   MyCAD1->AddShapeByCode(MyCAD1, SpPolyLine, "PolyLineShape", pMyPoint, 3);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditUndo1Execute(TObject *Sender)
{
if(MyCAD1->PopFromUndoRedoShapeList() == -1)
   {
   EditUndo1->Enabled = false;
   }
   else
   {
   EditUndo1->Enabled = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditLockExecute(TObject *Sender)
{
for (int i= 0; i < MyCAD1->GetSelectedShapesCount(); i++)
   {
   if (MyCAD1->GetSelectedShapes()[i] != NULL)
	  {
	  MyCAD1->LockUnLockforShapes(MyCAD1->GetSelectedShapes()[i],true);
	  Invalidate() ;
	  RefreshMenu();
	  }
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::EditUnlockExecute(TObject *Sender)
{
for (int i= 0; i < MyCAD1->GetSelectedShapesCount(); i++)
   {
   if (MyCAD1->GetSelectedShapes()[i] != NULL)
	  {
	  MyCAD1->LockUnLockforShapes(MyCAD1->GetSelectedShapes()[i],false);
	  Invalidate() ;
	  RefreshMenu();
	  }
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdPolyBezierExecute(TObject *Sender)
{
if (MyCAD1->GetShapeByName("PolyBezierShape") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 330;
   MyPoint[0].Y = 211;
   MyPoint[1].X = 380;
   MyPoint[1].Y = 211;
   MyPoint[2].X = 380;
   MyPoint[2].Y = 270;
   MyPoint[3].X = 530;
   MyPoint[3].Y = 270;

   TMyPoint *pMyPoint = MyPoint;
   MyCAD1->AddShapeByCode(MyCAD1, SpPolyBezier, "PolyBezierShape", pMyPoint, 3, 0);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdRectangleExecute(TObject *Sender)
{
if (MyCAD1->GetShapeByName("RectangleShape") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 290;
   MyPoint[0].Y = 211;
   MyPoint[1].X = 380;
   MyPoint[1].Y = 211;
   MyPoint[2].X = 380;
   MyPoint[2].Y = 270;
   MyPoint[3].X = 290;
   MyPoint[3].Y = 270;

   TMyPoint *pMyPoint = MyPoint;
   TMyShape* sa = MyCAD1->GetShapeByID(
MyCAD1->AddShapeByCode(MyCAD1, SpRectangle, "RectangleShape", pMyPoint, 3, 0));
   sa->MultiInfo->Add("aaaaaaa");
   sa->MultiInfo->Add("bbbbbbbb");
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdEllipseExecute(TObject *Sender)
{
if(MyCAD1->GetShapeByName("EllipseShape") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 380;
   MyPoint[0].Y = 261;
   MyPoint[1].X = 430;
   MyPoint[1].Y = 261;
   MyPoint[2].X = 430;
   MyPoint[2].Y = 320;
   MyPoint[3].X = 380;
   MyPoint[3].Y = 320;

   TMyPoint *pMyPoint = MyPoint;
   MyCAD1->AddShapeByCode(MyCAD1, SpEllipse, "EllipseShape", pMyPoint, 3);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::cdTextExecute(TObject *Sender)
{
MyCAD1->Font->Size = 12;

if (MyCAD1->GetShapeByName("TextShape4") == NULL)
   {
   TMyPoint MyPoint[10];
   MyPoint[0].X = 130;
   MyPoint[0].Y = 140;
   MyPoint[1].X = 200;
   MyPoint[1].Y = 140;
   MyPoint[2].X = 200;
   MyPoint[2].Y = 180;
   MyPoint[3].X = 130;
   MyPoint[3].Y = 180;

   TMyPoint *pMyPoint = MyPoint;

   TMyShape* aShape = MyCAD1->GetShapeByID(
MyCAD1->AddShapeByCode(MyCAD1, SpText, "TextShape4", pMyPoint, 3, 0, "hello world"));
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::opSnaptoShapeExecute(TObject *Sender)
{
MyCAD1->SnapShape = !MyCAD1->SnapShape;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::opTurboExecute(TObject *Sender)
{
TurboFrm->ShowModal();	
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::NicefitExecute(TObject *Sender)
{
double zw = ScrollBox1->Width/(MyCAD1->Width/MyCAD1->Zoom);
double zh = ScrollBox1->Height/(MyCAD1->Height/MyCAD1->Zoom);

if (zw < zh)
   MyCAD1->Zoom = zw;
else
   MyCAD1->Zoom = zh;

CenterCAD();
ZoomCmbBox->Text = IntToStr(Ceil(MyCAD1->Zoom*100))+"%";

}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AboutAboutExecute(TObject *Sender)
{
AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::ZoomCmbBoxChange(TObject *Sender)
{
switch (ZoomCmbBox->ItemIndex)
   {
	case 0: MyCAD1->Zoom = 0.5; break;
	case 1: MyCAD1->Zoom = 0.75; break;
	case 2: MyCAD1->Zoom = 1; break;
	case 3: MyCAD1->Zoom = 1.1; break;
	case 4: MyCAD1->Zoom = 1.3; break;
	case 5: MyCAD1->Zoom = 2.0; break;
	case 6: MyCAD1->Zoom = 4; break;
	case 7: MyCAD1->Zoom = 8; break;
   }
CenterCAD();
SetRuler();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::FormShow(TObject *Sender)
{
MyCAD1->SnapPixels = 4;
ZoomCmbBox->ItemIndex =2;
CenterCAD();
RsRuler1->HairLine = true;
RsRuler2->HairLine = true;
RsRuler1->HairLineStyle = hlsLine;
RsRuler2->HairLineStyle = hlsLine;
SetRuler();
MonitorParentShapesOnly = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::FormResize(TObject *Sender)
{
CenterCAD();	
}
//---------------------------------------------------------------------------








